/* ------------------------------------------------------------------------- */
/*
 *  time.h
 *
 *  Copyright (c) 2004 - 2006 "clown", All rights reserved.
 *
 *  Permission to copy, use, modify and distribute this software is
 *  granted provided this copyright notice appears in all copies.
 *  This software is provided "as is" without express or implied
 *  warranty, and with no claim as to its suitability for any purpose.
 *
 *  Last-modified: Mon 27 Feb 2006 16:29:00 JST
 */
/* ------------------------------------------------------------------------- */
#ifndef CLX_TIME_H
#define CLX_TIME_H

#include <ctime>

namespace clx {
	/* --------------------------------------------------------------------- */
	//  time
	/* --------------------------------------------------------------------- */
	class time {
	public:
		typedef unsigned int value_type;
		
		value_type year;
		value_type mon;
		value_type day;
		value_type hour;
		value_type min;
		value_type sec;
		
		time() : year(0), mon(0), day(0), hour(0), min(0), sec(0) {}
	};
	
	/* --------------------------------------------------------------------- */
	//  now
	/* --------------------------------------------------------------------- */
	void now(time& dest) {
		time_t t = ::time(NULL);
		struct tm tval;
		::localtime_r(&t, &tval);
		
		dest.year = tval.tm_year + 1900;
		dest.mon  = tval.tm_mon + 1;
		dest.day  = tval.tm_mday;
		dest.hour = tval.tm_hour;
		dest.min  = tval.tm_min;
		dest.sec  = tval.tm_sec;
	}
}

#endif // CLX_TIME_H
